TITLE 86eForth v5.2
.LIST
INCLUDE Irvine32.inc
PAGE 62,132	;62 lines per page, 132 characters per line
.LALL	
;===============================================================
;	86eForth V5.2, 9/4/2016
;1.	Use .stack, .code, and .data segments
;2.	Indirect threading, compile new words in .data segment
;3.	User variables stored in .data segment
;4.	Common Forth words in upper case
;5.	System words in lower case
;6.	71 code words, 110 colon words
;
;	86eForth v5.1, 8/26/2016
;1.	Combine 86eforth 2.03 and EF403
;2.	Visual Studio 2015 Community, MASM in C++ environment
;3.	Kip Irvine "Assembly Language for x86 Processors", 7th ed.
;4.	Call I/O in Irvine32.lib
;
;	86eForth 2.03, C. H. Ting, 04/06/2016
;	Load by build86_3.bat:
;	c:\masm32\bin\ml /c /Fl 86ef203.asm >86ef203.err
;	c:\masm32\bin\link16 86ef203.obj
;	86ef203
;	CALL doUSE/doCON changed to CALL @
;	CALL doVAR changed to CALL NOOP
;	TIB changed to a constant
;	_TYPE replaced by TYPE
;
;	86eForth 2.02, C. H. Ting, 06/02/99
;	Add create, checksum, UPLOAD and DOWNLOAD.
;	A sample session looks like:
;	c>86ef202
;	DOWNLOAD LESSONS.TXT
;	WORDS
;	' THEORY 'BOOT !
;	UPLOAD TEST.EXE
;	BYE
;	c>test
;
;	86eForth 2.01, C. H. Ting, 05/24/99
;	Merge Zen2.asm with eForth 1.12
;1.	Eliminate most of the @EXECUTE thru user variables
;2.	Combine name and code dictionary
;3.	Eliminate code pointer fields
;4.	elimiate catch-throw
;5.	eliminate most user variables
;6.	extend top memory to FFF0H where the stacks and user area are.
;7.	add open, close, read, write;	improve BYE
;8	add 1+, 1-, 2/
;	
;	eForth 1.12, C. H. Ting, 03/30/99
;	Change READ and LOAD to 'read' and 'load'.
;	Make LOAD to read and compile a file.  The file
;	buffer is from CP+1000 to NP-100.
;	To load all the lessons, type:
;	LOAD LESSONS.TXT
;	and you can test all the examples in this file.
;
;	eForth 1.11, C. H. Ting, 03/25/99
;	Change BYE to use function 4CH of INT 21H.
;	Add read, write, open, close, READ, and LOAD
;	To read a text file into memory:
;	HEX 2000 1000 READ TEST.TXT
;	READ returns the number of byte actually read.
;	To compile the source code in the text file:
;	2000 FCD LOAD
;	where FCD is the length returned by READ.
;	These additions allow code for other eForth systems
;	to be tested on PC first.
;	It is part of the Firmware Engineering Workshop.
;
;	486 eForth 4.03 by C. H. Ting, 1996, July 30, 1996
;	Can't replace BIOS because of chip set variations.
;	Replace Video ROM at C0000-C7FFF.
;	OK.EXE must be assembled by the following proceedure:
;	Copy 200-4FF in OK.EXE to ROM 0-2FF.	Loader
;	Copy 300-4FF in OK.EXE to ROM 4100-42FF.	GDT,IDT,misc.
;	Copy 800-44FF in OK.EXE to ROM 4300-7FFF.	eForth
;	Change last byte from FF to 36.	ROM checksum.
;	Install the 32KB ROM (27C256) in ROM socket on a video card.
;	Install video card and boot mother board.
;
;	486 eForth 4.02 by C. H. Ting, 1996, June 28
;	OK.ASM ported from Chuck Moore's HELLO.COM
;	EF402.ASM loaded with OK.ASM
;	>masm ok,,,,
;	>masm ef402,,,,
;	>link ok ef402,,,,
;	Resulting OK.EXE put eForth at a wrong location 5F0H.
;	It must be moved to 300H using CV
;	>cv ok
;	>n16
;	>r ds 50e7	align ds to cs
;	>m 5f0 l 4000 300
;	>g
;	OK.EXE thus fixed will jump to eForth in 32-bit protected
;	mode under DOS.
;
;	486 EfORTH 4.01 by C. H. Ting, 1996
;	32-bit eForth, protected mode under Chuck Moore's OK
;	Strip first 300H bytes from EF401.EXE to make EF401.COM
;	Under OK type:
;	>load EF401.COM
;	>debug HELLO32.COM
;	-g
;	4.01 is running from 110000H as logical 0.
;	HELLO32.COM is derived from Chuck's HELLO.COM except
;	in 32-bit mode with 32-bit flat address.
;
;	386 eForth 3.01 by C. H. Ting, 1996
;	16-bit protected mode to be used with Chuck Moore's OK.
;
;	eForth 1.0 by Bill Muench and C. H. Ting, 1990
;	Much of the code is derived from the following sources:
;	8086 figForth by Thomas Newman, 1981 and Joe smith, 1983
;	aFORTH by John Rible
;	bFORTH by Bill Muench
;
;	The goal of this implementation is to provide a simple eForth Model
;	which can be ported easily to many 8, 16, 24 and 32 bit CPU's.
;	The following attributes make it suitable for CPU's of the '90:
;
;	small machine dependent kernel and portable high level code
;	source code in the MASM format
;	direct threaded code
;	separated code and name dictionaries
;	simple vectored terminal and file interface to host computer
;	aligned with the proposed ANS Forth Standard
;	easy upgrade path to optimize for specific CPU
;
;	You are invited to implement this Model on your favorite CPU and
;	contribute it to the eForth Library for public use. You may use
;	a portable implementation to advertise more sophisticated and
;	optimized version for commercial purposes. However, you are
;	expected to implement the Model faithfully. The eForth Working
;	Group reserves the right to reject implementation which deviates
;	significantly from this Model.
;
;	As the ANS Forth Standard is still evolving, this Model will
;	change accordingly. Implementations must state clearly the
;	version number of the Model being tracked.
;
;	Representing the eForth Working Group in the Silicon Valley FIG Chapter.
;	Send contributions to:
;
;	Dr. C. H. Ting
;	156 14th Avenue
;	San Mateo, CA 94402
;	(650) 571-7639
;	chenhting@yahoo.com.tw
;
;===============================================================

;	Version control

VER	EQU	5	;major release version
EXT	EQU	2	;minor extension

;	Constants

TRUEE	EQU	-1	;true flag

COMPO	EQU	040H	;lexicon compile only bit
IMEDD	EQU	080H	;lexicon immediate bit
MASKK	EQU	0FF1FH	;lexicon bit mask for count and 1st byte

CELLL	EQU	4	;size of a cell
BASEE	EQU	16	;default radix

BKSPP	EQU	8	;back space
LF	EQU	10	;line feed
CRR	EQU	13	;carriage return

;	Initialize assembly variables

_LINK	= 0	; Save link field address 
_CODE	= 0	; Save code field address 

;	Define assembly macros

;	Compile a code definition header.

$CODE	MACRO	LEX,NAME,LABEL	; Macro for code words 
	DD	_LINK	; Build a link field 
	_LINK	= $	; Save name field address for next link 
	DB	LEX,NAME	; Lexicon byte and name string 
LABEL:	
	_CODE	=	$	; Save code field address 
	DD	_CODE+CELLL	; Store pfa in code field 
	ENDM

;	Compile a colon definition header.

$COLON	MACRO	LEX,NAME,LABEL	; Macro for colon words 
	DD	_LINK	; Build link field 
	_LINK	= $	; Save name field address for next link 
	DB	LEX,NAME	; Lexicon byte and name string 
LABEL:	
	DD	DOLST	; Address interpreter for colon word 
	ENDM

;	Assemble inline indirect threaded code ending.

$NEXT	MACRO	; Macro to add inner interpreter to end code words 
	LODSD	; Read the next code address into EAX 
	JMP	DWORD PTR [EAX]	;jump indirectly to the code address in EAX
	ENDM

;	Stack defined in Irvine32.inc

;	System variables, TIB and user dictionary

.data
UZERO	DD	0	;start of variable area 
_SPP	DD	0	;SP0, bottom of the data stack 
_RPP	DD	0	;RP0, bottom of the return stack 
_BASE	DD	BASEE	;BASE, radix base for numeric I/O 
_TMP	DD	0	;TMP, temporary storage 
_IN	DD	0	;>IN, current character pointer to input string 
_SPAN	DD	0	;SPAN, character count received by EXPECT 
_NTIB	DD	0	;#TIB, end of input string 
_TIBB	DD	_TIB	;TIB, beginning of input string 
_EVAL	DD	0	;EVAL, execution vector for EVAL 
_HLD	DD	0	;HLD, next character in numeric output string 
_CNTXT	DD	OFFSET LASTN	;CONTEXT pointer
_CP	DD	_CPP	;CP, top of dictionary 
_LASTN	DD OFFSET LASTN	;LAST, initial CONTEXT 
ULAST	DD	0
_TIB	DD	20 DUP(0)	;terminal input buffer 
_CPP	DD	4096 DUP(0)	; user dictionary 
.code	; Start of code segment 
MAIN	PROC	; Entrance 
	XOR	EAX,EAX
	PUSH	EAX	; Init data stack 
	PUSH	EAX	; Clear top of data stack 
	PUSH	EAX
	PUSH	EAX
	MOV	EAX,ESP	; Initialize data stack pointer ESP 
	MOV	_SPP,EAX	; Save ESP for ABORT 
	SUB	EAX,800H
	MOV	EBP,EAX	; Initialize return stack pointer EBP 
	MOV	_RPP,EAX	; Save EBP for QUIT 
	CLD	; Clear direction flag, incrementing ESI 
	MOV	EAX,COLD	; High level cold start 
	JMP	DWORD PTR [EAX]	; Jump indirectly to the code address 

DOLST:	; Colon word address interpreter 
	XCHG	EBP,ESP	; Exchange the return and data stack pointers
	PUSH	ESI	; Push IP on return stack
	XCHG	EBP,ESP	; Restore stack pointers
	ADD	EAX,CELLL	; EAX now points to parameter field 
	MOV	ESI,EAX	; New list address in IP 
	LODSD	; Read the next code address into EAX 
	JMP	DWORD PTR [EAX]	; Jump indirectly to the code field address 
DOVAR: ;	variable interpreter	
	ADD	EAX,CELLL	; Increment EAX pointing to parameter field 
	PUSH	EAX	; Push pfa on data stack 
	$NEXT

DOCON:	;	constant interpreter
	ADD	EAX,CELLL	; Increment EAX pointing to parameter field 
	PUSH	DWORD PTR [EAX]	; Push value in parameter field on data stack 
	$NEXT

;	System interface

;	BYE	( -- )
;	Exit eForth. 

	$CODE	3,'BYE',BYE
	invoke ExitProcess,0	; Return to Windows 

;	?RX	( -- c T | F )
;	Return input character and true, or a false if no input.

	$CODE	4,'?KEY',QKEY
	XOR	EBX,EBX	;EBX=0 setup for false flag
	XOR	EAX,EAX	; EAX=0 prepare to receive one character 
	call	ReadKey	; Call system service 
	JZ	SHORT QRX3	; Got a key? Jump if not.
	PUSH	EAX	; Save character
	DEC	EBX	; Make a true flag 
QRX3:	PUSH	EBX	; Save flag 
	$NEXT

;	KEY	( -- c )
;	Wait for and return an input character.

	$CODE	3,'KEY',KEY
	call	ReadChar	; Wait for character 
	AND	EAX,07FH	; Mask non-printable 
	PUSH	EAX	; Save character 
	$NEXT

;	EMIT	( c -- )
;	Send character c to the output device.

	$CODE	4,'EMIT',EMIT
	POP	EAX
	call	WriteChar	; Display character on console 
	$NEXT

;	The kernel

;	EXECUTE	( cfa -- )
;	Execute the word at cfa.

	$CODE	7,'EXECUTE',EXECU
	POP	EAX	; Get code field address 
	JMP	DWORD PTR [EAX]	; Jump indirectly to the address in code field 

;	EXIT	( -- )
;	Terminate a colon definition.

	$CODE	4,'EXIT',EXITT
	XCHG	EBP,ESP	;exchange pointers
	POP	ESI	;pop return stack
	XCHG	EBP,ESP	;restore stack pointers
	$NEXT

;	DOLIT	( -- w )
;	Push an inline literal.

	$CODE	COMPO+5,'dolit',DOLIT
	LODSD	; Load next token into EAX 
	PUSH	EAX	; Push it as a literal value 
	$NEXT

;	?BRANCH	( f -- )
;	Branch if flag is zero.

	$CODE	COMPO+7,'?branch',QBRAN
	POP	EAX	;pop flag
	OR	EAX,EAX	;?flag=0
	JZ	SHORT BRAN1	;yes, do branch
	ADD	ESI,CELLL	;point IP to next cell
	$NEXT

;	BRANCH	( -- )
;	Branch to an inline address.

	$CODE	COMPO+6,'branch',BRAN
BRAN1:	MOV	ESI,0[ESI]	; IP=[IP]. Do the branching 
	$NEXT

;	DONXT	( -- )
;	Run time code for the single index loop.

	$CODE	COMPO+5,'donxt',DONXT
	SUB	DWORD PTR [EBP],1	; decrement loop index on return stack 
	JC	SHORT NEXT1	; decrement below 0?
	MOV	ESI,0[ESI]	; no, continue loop. IP=[IP]
	$NEXT
NEXT1:
	ADD	EBP,CELLL	;yes, pop loop index
	ADD	ESI,CELLL	; exit loop. Increment IP to next token 
	$NEXT

;	!	( w a -- )
;	Pop the data stack to memory.

	$CODE	1,'!',STORE
	POP	EBX	; pop address a 
	POP	0[EBX]	; pop w and store it in a 
	$NEXT

;	@	( a -- w )
;	Push memory location to the data stack.

	$CODE	1,'@',AT
	POP	EBX	; pop address a 
	PUSH	0[EBX]	; push contents of a 
	$NEXT

;	C!	( c b -- )
;	Pop the data stack to byte memory.

	$CODE	2,'C!',CSTOR
	POP	EBX	; pop address b 
	POP	EAX	; pop byte c 
	MOV	0[EBX],AL	; store c in b 
	$NEXT

;	C@	( b -- c )
;	Push byte memory location to the data stack.

	$CODE	2,'C@',CAT
	POP	EBX	; pop address b 
	XOR	EAX,EAX	; clear EAX to receive one byte
	MOV	AL,0[EBX]	; get one byte c at b 
	PUSH	EAX	; push c 
	$NEXT

;	RP@	( -- a )
;	Push the current RP to the data stack.

	$CODE	3,'rp@',RPAT
	PUSH	EBP	; push RP on stack 
	$NEXT

;	RP!	( a -- )
;	Set the return stack pointer.

	$CODE	COMPO+3,'rp!',RPSTO
	POP	EBP	; pop a and store it in RP 
	$NEXT

;	R>	( -- w )
;	Pop the return stack to the data stack.

	$CODE	2,'R>',RFROM
	PUSH	0[EBP]	; push top of return stack on data stack 
	ADD	EBP,CELLL	; adjust RP 
	$NEXT

;	R@	( -- w )
;	Copy top of return stack to the data stack.

	$CODE	2,'R@',RAT
	PUSH	0[EBP]	; push top of return stack on data stack 
	$NEXT	; leave RP alone 

;	>R	( w -- )
;	Push the data stack to the return stack.

	$CODE	COMPO+2,'>R',TOR
	SUB	EBP,CELLL	; adjust RP 
	POP	0[EBP]	; pop w and store it on return stack 
	$NEXT

;	SP@	( -- a )
;	Push the current data stack pointer.

	$CODE	3,'sp@',SPAT
	MOV	EAX,ESP	; Get data stack pointer ESP 
	PUSH	EAX	; Push it 
	$NEXT

;	SP!	( a -- )
;	Set the data stack pointer.

	$CODE	3,'sp!',SPSTO
	POP	EAX	; Pop a 
	MOV	ESP,EAX	; Store it in ESP 
	$NEXT

;	DROP	( w -- )
;	Discard top stack item.

	$CODE	4,'DROP',DROP
	POP	EAX	; pop it 
	$NEXT

;	DUP	( w -- w w )
;	Duplicate the top stack item.

	$CODE	3,'DUP',DUPP
	POP	EAX	; pop w 
	PUSH	EAX	; push w twice 
	PUSH	EAX
	$NEXT

;	SWAP	( w1 w2 -- w2 w1 )
;	Exchange top two stack items.

	$CODE	4,'SWAP',SWAP
	POP	EBX	; pop w2
	POP	EAX	; pop w1
	PUSH	EBX	; push w2
	PUSH	EAX	; push w1
	$NEXT

;	OVER	( w1 w2 -- w1 w2 w1 )
;	Copy second stack item to top.

	$CODE	4,'OVER',OVER
	MOV	EAX, 4[ESP]	; get w1
	PUSH	EAX	; push w1
	$NEXT

;	0<	( n -- t )
;	Return true if n is negative.

	$CODE	2,'0<',ZLESS
	POP	EAX	; pop n 
	CDQ	; sign extend EAX to EDX 
	PUSH	EDX	; push sign as flag
	$NEXT

;	AND	( w w -- w )
;	Bitwise AND.

	$CODE	3,'AND',ANDD
	POP	EAX
	POP	EBX
	AND	EAX,EBX; AND
	PUSH	EAX
	$NEXT

;	OR	( w w -- w )
;	Bitwise inclusive OR.

	$CODE	2,'OR',ORR
	POP	EAX
	POP	EBX
	OR	EAX,EBX	; OR
	PUSH	EAX
	$NEXT

;	XOR	( w w -- w )
;	Bitwise exclusive OR.

	$CODE	3,'XOR',XORR
	POP	EAX
	POP	EBX
	XOR	EAX,EBX	; XOR
	PUSH	EAX
	$NEXT

;	UM+	( w w -- w cy )
;	Add two numbers, return the sum and carry flag.

	$CODE	3,'UM+',UPLUS
	XOR	ECX,ECX	; ECX=0 initial carry flag
	POP	EBX
	POP	EAX
	ADD	EAX,EBX	; ADD
	RCL	ECX,1	;get carry
	PUSH	EAX	;push sum
	PUSH	ECX	;push carry
	$NEXT

;	System variables

;	SP0	( -- a )
;	Pointer to bottom of the data stack.

	$CODE	3,'sp0',SZERO
	LEA	EAX,_SPP	; bottom of data stack 
	PUSH	EAX	; push 
	$NEXT

;	RP0	( -- a )
;	Pointer to bottom of the return stack.

	$CODE	3,'rp0',RZERO
	LEA	EAX,_RPP 	; bottom of return stack 
	PUSH	EAX	; push 
	$NEXT

;	BASE	( -- a )
;	Storage of the radix base for numeric I/O.

	$CODE	4,'base',BASE
	LEA	EAX,_BASE	; Radix for number conversion 
	PUSH	EAX	; push 
	$NEXT

;	TMP	( -- a )
;	A temporary storage location used in parse and find.

	$CODE	COMPO+3,'tmp',TEMP
	LEA	EAX,_TMP	; Temporary storage 
	PUSH	EAX	; push 
	$NEXT

;	SPAN	( -- a )
;	Hold character count received by EXPECT.

	$CODE	4,'span',SPAN
	LEA	EAX,_SPAN	; Character count received 
	PUSH	EAX	; push 
	$NEXT

;	>IN	( -- a )
;	Hold the character pointer while parsing input stream.

	$CODE	3,'>in',INN
	LEA	EAX,_IN	; Parser pointer 
	PUSH	EAX	; push 
	$NEXT

;	#TIB	( -- a )
;	Hold the current count and address of the terminal input buffer.

	$CODE	4,'#tib',NTIB
	LEA	EAX,_NTIB	; Pointer to end of input buffer 
	PUSH	EAX	; push 
	$NEXT

;	HLD	( -- a )
;	Hold a pointer in building a numeric output string.

	$CODE	3,'hld',HLD
	LEA	EAX,_HLD	; Pointer to output number string 
	PUSH	EAX	; push 
	$NEXT

;	'EVAL	( -- a )
;	Hold a pointer in building a numeric output string.

	$CODE	5,"'eval",TEVAL
	LEA	EAX,_EVAL	; Execution vector for text interpreter 
	PUSH	EAX	; push 
	$NEXT

;	CONTEXT	( -- a )
;	A area to specify vocabulary search order.

	$CODE	7,'context',CNTXT
	LEA	EAX,_CNTXT	; Pointer to last name 
	PUSH	EAX	; push 
	$NEXT

;	CP	( -- a )
;	Point to the top of the code dictionary.

	$CODE	2,'cp',CP
	LEA	EAX,_CP	; Pointer to top of dictionary 
	PUSH	EAX	; push 
	$NEXT

;	LAST	( -- a )
;	Point to the last name in the name dictionary.

	$CODE	4,'last',LAST
	LEA	EAX,_LASTN	; Initial value for CONTEXT 
	PUSH	EAX	; push 
	$NEXT

;	Common functions

;	?DUP	( w -- w w | 0 )
;	Dup tos if its is not zero.

	$CODE	4,'?DUP',QDUP
	POP	EAX
	OR	EAX,EAX	; test tos 
	JZ	SHORT QDUP1
	PUSH	EAX 	; push twice 
QDUP1:	PUSH	EAX	; push once 
	$NEXT

;	ROT	( w1 w2 w3 -- w2 w3 w1 )
;	Rotate 3rd item to top.

	$CODE	3,'ROT',ROT
	POP	EAX	; pop all 3 items 
	POP	EBX
	POP	ECX
	PUSH	EBX	; push them in desired order 
	PUSH	EAX
	PUSH	ECX
	$NEXT

;	2DROP	( w w -- )
;	Discard two items on stack.

	$CODE	5,'2DROP',DDROP
	POP	EAX	; drop
	POP	EAX	; drop
	$NEXT

;	2DUP	( w1 w2 -- w1 w2 w1 w2 )
;	Duplicate top two items.

	$CODE	4,'2DUP',DDUP
	POP	EAX	; Pop w2
	POP	EBX	; Pop w1
	PUSH	EBX	; push w1
	PUSH	EAX	; push w2
	PUSH	EBX	; push w1
	PUSH	EAX	; push w2
	$NEXT

;	+	( w w -- sum )
;	Add top two items.

	$CODE	1,'+',PLUS
	POP	EAX
	POP	EBX
	ADD	EAX,EBX	; ADD
	PUSH	EAX
	$NEXT

;	D+	( d d -- d )
;	Double integer addition.
;
	$CODE	2,'D+',DPLUS
	POP	EAX
	POP	EDX
	POP	EBX
	POP	ECX
	ADD	EDX,ECX	; add lower half 
	ADC	EAX,EBX	; add upper half with carry 
	PUSH	EDX	; push lower sum 
	PUSH	EAX	; push upper sum 
	$NEXT

;	NOT	( w -- w )
;	One's complement of tos.

	$CODE	3,'NOT',INVER
	POP	EAX
	NOT	EAX	; invert all bits 
	PUSH	EAX
	$NEXT

;	NEGATE	( n -- -n )
;	Two's complement of tos.

	$CODE	6,'NEGATE',NEGAT
	POP	EAX
	NEG	EAX	; negate 
	PUSH	EAX
	$NEXT

;	DNEGATE	( d -- -d )
;	Two's complement of top double integer.

	$CODE	7,'DNEGATE',DNEGA
	POP	EAX	; dh 
	POP	EDX	; dl 
	NEG	EAX	; negate dh 
	NEG	EDX	; negate dl 
	SBB	EAX,0	; Carry into dh 
	PUSH	EDX
	PUSH	EAX
	$NEXT

;	-	( n1 n2 -- n1-n2 )
;	Subtraction.

	$CODE	1,'-',SUBBB
	POP	EBX
	POP	EAX
	SUB	EAX,EBX	; SUB 
	PUSH	EAX
	$NEXT

;	ABS	( n -- n )
;	Return the absolute value of n.

	$CODE	3,'ABS',ABSS
	POP	EAX
	OR	EAX,EAX
	JGE	SHORT ABS1	; Positive?
	NEG	EAX	; negative 
ABS1:	PUSH	EAX
	$NEXT

; Comparison 

;	=	( w w -- t )
;	Return true if top two are equal.

	$CODE	1,'=',EQUAL
	XOR	EAX,EAX	; init a false flag 
	POP	EDX
	POP	EBX
	XOR	EDX,EBX	; compare 
	JNZ	SHORT EQU1 
	DEC	EAX	; change false flag to true flag 
EQU1:	PUSH	EAX
	$NEXT

;	U<	( u u -- t )
;	Unsigned compare of top two items.

	$CODE	2,'U<',ULESS
	POP	EBX
	POP	EAX
	SUB	EAX,EBX	; compare 
	SBB	EAX,EAX	; use carry to generate true or false flag 
	PUSH	EAX
	$NEXT

;	<	( n1 n2 -- t )
;	Signed compare of top two items.

	$CODE	1,'<',LESS
	XOR	EAX,EAX
	POP	EBX
	POP	ECX
	SUB	ECX,EBX	; compare 
	JGE	SHORT LESS1
	DEC	EAX	; make true flag 
LESS1:	PUSH	EAX
	$NEXT

;	MAX	( n n -- n )
;	Return the greater of two top stack items.

	$CODE	3,'MAX',MAX
	POP	EBX
	POP	EAX
	CMP	EAX,EBX	; compare 
	JGE	SHORT MAX1	; select larger 
	XCHG	EAX,EBX
MAX1:	PUSH	EAX
	$NEXT

;	MIN	( n n -- n )
;	Return the smaller of top two stack items.

	$CODE	3,'MIN',MIN
	POP	EBX
	POP	EAX
	CMP	EAX,EBX	; compare 
	JGE	SHORT MIN1	; select smaller 
	XCHG	EAX,EBX
MIN1:	PUSH	EBX
	$NEXT

;	WITHIN	( u ul uh -- t )
;	Return true if u is within the range of ul and uh.

	$COLON	6,'WITHIN',WITHI
	DD	OVER,SUBBB,TOR	; range between ul and uh 
	DD	SUBBB,RFROM,ULESS,EXITT 	; range between ul and uh 

;	Divide

;	UM/MOD	( udl udh un -- ur uq )
;	Unsigned divide of a double by a single. Return mod and quotient.

	$CODE	6,'UM/MOD',UMMOD
	POP	EBX	; un
	POP	EDX	; udh
	POP	EAX	; udl
	OR	EBX,EBX	; If un=0
	JNZ	SHORT UMM1	; then, return two -1
UMM:	MOV	EAX,-1
	PUSH	EAX
	PUSH	EAX
	$NEXT
UMM1:	DIV	EBX	; else, unsigned divide
	PUSH	EDX	; remainder
	PUSH	EAX	; quotient
	$NEXT

;	M/MOD	( d n -- r q )
;	Signed floored divide of double by single. Return mod and quotient.

	$CODE	5,'M/MOD',MSMOD
	POP	EBX	; n
	POP	EDX	; dh
	POP	EAX	; dl
	OR	EBX,EBX	; If n=0
	JZ	SHORT UMM	; then, return two -1
MSM1:	IDIV	EBX	; else signed divide 
	PUSH	EDX	; remainder
	PUSH	EAX	; quotient
	$NEXT

;	/MOD	( n1 n2 -- r q )
;	Signed divide. Return mod and quotient.

	$COLON	4,'/MOD',SLMOD
	DD	OVER,ZLESS 	; sign extend n1
	DD	SWAP,MSMOD,EXITT	; floored divide 

;	MOD	( n n -- r )
;	Signed divide. Return mod only.

	$COLON	3,'MOD',MODD
	DD	SLMOD,DROP,EXITT	; divide and discard remainder 

;	/	( n n -- q )
;	Signed divide. Return quotient only.

	$COLON	1,'/',SLASH
	DD	SLMOD,SWAP,DROP,EXITT	; divide and discard quotient 

;	Multiply

;	UM*	( u u -- ud )
;	Unsigned multiply. Return double product.

	$CODE	3,'UM*',UMSTA
	POP	EAX
	POP	EBX
	MUL	EBX	; unsigned multiply 
	PUSH	EAX
	PUSH	EDX
	$NEXT

;	*	( n n -- n )
;	Signed multiply. Return single product.

	$CODE	1,'*',STAR
	POP	EAX
	POP	EBX
	IMUL	EBX	; signed multiply 
	PUSH	EAX
	$NEXT

;	M*	( n n -- d )
;	Signed multiply. Return double product.

	$CODE	2,'M*',MSTAR
	POP	EBX
	POP	EAX
	IMUL	EBX	; signed multiply 
	PUSH	EAX
	PUSH	EDX
	$NEXT

;	Scaling

;	*/MOD	( n1 n2 n3 -- r q )
;	Multiply n1 and n2, then divide by n3. Return mod and quotient.

	$COLON	5,'*/MOD',SSMOD
	DD	TOR,MSTAR 	; n1*n2
	DD	RFROM,MSMOD,EXITT	; n1*n2/n3 with remainder 

;	*/	( n1 n2 n3 -- q )
;	Multiply n1 by n2, then divide by n3. Return quotient only.

	$COLON	2,'*/',STASL
	DD	SSMOD	; n1*n2/n3
	DD	SWAP,DROP,EXITT	; discard remainder 

;	Miscellaneous

;	4+	( a -- a+4 )
;	Add cell size in byte to address.

	$CODE	2,'4+',CELLP
	POP	EAX
	ADD	EAX,CELLL	; plus 4
	PUSH	EAX
	$NEXT

;	4-	( a -- a-4 )
;	Subtract cell size in byte from address.

	$CODE	2,'4-',CELLM
	POP	EAX
	SUB	EAX,CELLL	; minus 4
	PUSH	EAX
	$NEXT

;	4*	( n -- 4n )
;	Multiply tos by cell size in bytes.

	$CODE	2,'4*',CELLS
	POP	EAX
	SHL	EAX,2	; shift left 2 bits
	PUSH	EAX
	$NEXT

;	1+	( a -- a+1 )
;	Add cell size in byte to address.

	$CODE	2,'1+',ONEP
	POP	EAX
	ADD	EAX,1	; increment 
	PUSH	EAX
	$NEXT

;	1-	( a -- a-1 )
;	Subtract cell size in byte from address.

	$CODE	2,'1-',ONEM
	POP	EAX
	SUB	EAX,1	; decrement 
	PUSH	EAX
	$NEXT

;	2+	( a -- a+2 )
;	Add cell size in byte to address.

	$CODE	2,'2+',TWOP
	POP	EAX
	ADD	EAX,2	; increment by 2
	PUSH	EAX
	$NEXT

;	2-	( a -- a+2 )
;	Subtract cell size in byte from address.

	$CODE	2,'2-',TWOM
	POP	EAX
	SUB	EAX,2	; Decrement by 2
	PUSH	EAX
	$NEXT

;	BL	( -- 32 )
;	Return 32, the blank character.

	$COLON	2,'BL',BLANK
	DD	DOLIT,' ',EXITT	; blank 

;	>CHAR	( c -- c )
;	Filter non-printing characters.

	$COLON	5,'>char',TCHAR
	DD	DOLIT,07FH,ANDD,DUPP	;mask msb
	DD	DOLIT,127,BLANK,WITHI	;check for printable
	DD	QBRAN,TCHA1
	DD	DROP,DOLIT,'_'	;replace non-printables
TCHA1:
	DD	EXITT

;	DEPTH	( -- n )
;	Return the depth of the data stack.

	$COLON	5,'depth',DEPTH
	DD	SPAT,DOLIT,_SPP,AT	; top and bottom of data stack 
	DD	SWAP,SUBBB	; diff
	DD	DOLIT,CELLL,SLASH,EXITT	; divide by 4

;	PICK	( ... +n -- ... w )
;	Copy the nth stack item to tos.

	$COLON	4,'PICK',PICK
	DD	ONEP,CELLS	; 0 based 
	DD	SPAT,PLUS,AT,EXITT	; reach into data stack 

;	Memory access

;	+!	( n a -- )
;	Add n to the contents at address a.

	$CODE	2,'+!',PSTOR
	POP	EBX
	POP	EAX
	ADD	0[EBX],EAX	; add n to [a]
	$NEXT

;	2!	( d a -- )
;	Store the double integer to address a.

	$CODE	2,'2!',DSTOR
	POP	EBX 
	POP	0[EBX] 	; dl 
	POP	4[EBX]	; dh 
	$NEXT

;	2@	( a -- d )
;	Fetch double integer from address a.

	$CODE	2,'2@',DAT
	POP	EBX
	PUSH	4[EBX]	; dh 
	PUSH	0[EBX]	; dl 
	$NEXT

;	HERE	( -- a )
;	Return the top of the code dictionary.

	$COLON	4,'HERE',HERE
	DD	CP,AT,EXITT	; [cp]

;	PAD	( -- a )
;	Return the address of the text buffer above the code dictionary.

	$COLON	3,'PAD',PAD
	DD	HERE,DOLIT,80,PLUS,EXITT	; [cp]+80

;	TIB	( -- a )
;	Return the address of the terminal input buffer.

	$COLON	3,'TIB',TIB
	DD	DOLIT,_TIB,EXITT	; terminal input buffer 

;	@EXECUTE	( a -- )
;	Execute vector stored in address a.

	$COLON	8,'@EXECUTE',ATEXE
	DD	AT,QDUP	; address or zero?
	DD	QBRAN,EXE1
	DD	EXECU	;execute if non-zero
EXE1:
	DD	EXITT	;do nothing if zero

;	COUNT   ( b -- b +n )
;	Return count byte of a string and add 1 to byte address.

	$CODE	5,'COUNT',COUNT
	POP	EBX	; get b 
	XOR	EAX,EAX	; clear EAX to receive one byte 
	MOV	AL,0[EBX]	; get c 
	INC	EBX	; increment b 
	PUSH	EBX	; push b+1
	PUSH	EAX	; push c 
	$NEXT

;	CMOVE	( b1 b2 u -- )
;	Copy u bytes from b1 to b2.

	$CODE	5,'CMOVE',CMOVEE
	MOV	EBX,ESI	;save IP
	POP	ECX	; get count 
	POP	EDI
	POP	ESI
	REP   MOVSB	; repeat move bytes 
	MOV	ESI,EBX	;restore IP
	$NEXT

;	FILL	( b u c -- )
;	Fill u bytes of character c to area beginning at b.

	$CODE	4,'FILL',FILL
	POP	EAX	; get byte pattern c 
	POP	ECX	; get count u 
	POP	EDI	; get address b 
	REP   STOSB	; repeat store bytes 
	$NEXT

;	ERASE	( b u -- )
;	Erase u bytes beginning at b.

	$COLON	5,'ERASE',ERASE
	DD	DOLIT,0,FILL	; just fill with 0
	DD	EXITT

;	PACK$	( b u a -- a )
;	Build a counted at a from string with u characters at b. 

	$COLON	5,'pack$',PACKS
	DD	DUPP,TOR	;save count
	DD	DDUP,CSTOR,ONEP ;store count
	DD	SWAP,CMOVEE,RFROM,EXITT	;move string

;	Numeric output

;	DIGIT	( u -- c )
;	Convert digit u to a character.

	$COLON	5,'digit',DIGIT
	DD	DOLIT,9,OVER,LESS	; If u>9, 
	DD	DOLIT,7,ANDD,PLUS	; add 7 for a hex number.
	DD	DOLIT,'0',PLUS,EXITT	; convert to ASCII 

;	EXTRACT	( n base -- n c )
;	Extract the least significant digit from n.

	$COLON	7,'extract',EXTRC
	DD	DOLIT,0,SWAP,UMMOD	; extract least significant digit 
	DD	SWAP,DIGIT,EXITT	; convert to ASCII digit 

;	<#	( -- )
;	Initiate the numeric output process.

	$COLON	2,'<#',BDIGS
	DD	PAD,HLD,STORE,EXITT	; point HLD to PAD to accept numeric digits 

;	HOLD	( c -- )
;	Insert a character into the numeric output string.

	$COLON	4,'HOLD',HOLD
	DD	HLD,AT,ONEM	; decrement HLD 
	DD	DUPP,HLD,STORE 	; digits are stored in reverse order 
	DD	CSTOR,EXITT	; store digit c 

;	#	( u -- u )
;	Extract one digit from u and append the digit to output string.

	$COLON	1,'#',DIG
	DD	BASE,AT,EXTRC	; extract least significant digit
       Dd	HOLD,EXITT	; append it to numeric output string 

;	#S	( u -- 0 )
;	Convert u until all digits are added to the output string.

	$COLON	2,'#S',DIGS
DIGS1:
	DD	DIG,DUPP	; append one digit 
	DD	QBRAN,DIGS2	; If u is not 0,
	DD	BRAN,DIGS1	; repeat until u is reduced to 0
DIGS2:
	DD	EXITT

;	SIGN	( n -- )
;	Add a minus sign to the numeric output string.

	$COLON	4,'SIGN',SIGN
	DD	ZLESS	; If n<0,
	DD	QBRAN,SIGN1
	DD	DOLIT,'-',HOLD	; append minus sign 
SIGN1:
	DD	EXITT

;	#>	( w -- b u )
;	Prepare the output string to be TYPE'd.

	$COLON	2,'#>',EDIGS
	DD	DROP,HLD,AT	; replace w with HLD 
	DD	PAD,OVER,SUBBB,EXITT	; return length of string

;	STR	( w -- b u )
;	Convert a signed integer to a numeric string.

	$COLON	3,'str',STRR
	DD	DUPP,TOR,ABSS	; save w for SIGN, and change w to absolute 
	DD	BDIGS,DIGS,RFROM	; extract all digits of absolute value 
	DD	SIGN,EDIGS,EXITT	; append sign and return buffer and length 

;	.R	( n +n -- )
;	Display an integer in a field of n columns, right justified.

	$COLON	2,'.R',DOTR
	DD	TOR,STRR,RFROM	; save column width +n and convert w
	DD	OVER,SUBBB,SPACS	; display spaces for right justification 
	DD	TYPES,EXITT	; display number string 

;	U.R	( u +n -- )
;	Display an unsigned integer in n column, right justified.

	$COLON	3,'U.R',UDOTR
	DD	TOR,BDIGS,DIGS,EDIGS	; convert unsigned integer w 
	DD	RFROM,OVER,SUBBB,SPACS	; add spaces for right justification 
	DD	TYPES,EXITT	; display number string 

;	U.	( u -- )
;	Display an unsigned integer in free format.

	$COLON	2,'U.',UDOT
	DD	BDIGS,DIGS,EDIGS	; convert unsigned integer w 
	DD	SPACE,TYPES,EXITT	; add  space and display number string 

;	.	( w -- )
;	Display an integer in free format, preceeded by a space.

	$COLON	1,'.',DOT
	DD	BASE,AT,DOLIT,10,XORR	; decimal?
	DD	QBRAN,DOT1
	DD	UDOT,EXITT	;no, display unsigned
DOT1:
	DD	STRR,SPACE,TYPES,EXITT	;yes, display signed

;	?	( a -- )
;	Display the contents in a memory cell.

	$COLON	1,'?',QUEST
	DD	AT,DOT,EXITT

;	HEX	( -- )
;	Use radix 16 as base for numeric conversions.

	$COLON	3,'HEX',HEX
	DD	DOLIT,16,BASE,STORE,EXITT

;	DECIMAL	( -- )
;	Use radix 10 as base for numeric conversions.

	$COLON	7,'DECIMAL',DECIM
	DD	DOLIT,10,BASE,STORE,EXITT

;	Numeric input

;	DIGIT?	( c base -- u t )
;	Convert a character to its numeric value. A flag indicates success.

	$COLON	6,'digit?',DIGTQ
	DD	TOR,DOLIT,'0',SUBBB	; save radix, convert ASCII to digit 
	DD	DOLIT,9,OVER,LESS	; is digit greater than 9?
	DD	QBRAN,DGTQ1
	DD	DOLIT,7,SUBBB	; Yes. Convert hex to decimal digit 
	DD	DUPP,DOLIT,10,LESS,ORR	; If digit<10, change it to -1
DGTQ1:
	DD	DUPP,RFROM,ULESS,EXITT	; If digit >= base, return a false flag 

;	NUMBER?	( a -- n T | a F )
;	Convert a number string to integer. Push a flag on tos.

	$COLON	7,'number?',NUMBQ
	DD	BASE,AT,TOR 	; save the current radix in BASE 
	DD	DOLIT,0,OVER,COUNT	; a 0 a+1 n --, get length of the string 
	DD	OVER,CAT,DOLIT,'$',EQUAL	; is 1st digit a $ for hexadecimal base?
	DD	QBRAN,NUMQ1
	DD	HEX,SWAP,ONEP	; Yes, use hexadecimal base and adjust string 
	DD	SWAP,ONEM	; a 0 a+2 n-1 --
NUMQ1:
	DD	OVER,CAT 	; get next digit 
	DD	DOLIT,'-',EQUAL,TOR	; Is it a - sign? Save flag.
	DD	SWAP,RAT,SUBBB,SWAP 	; a 0 b' n' --, adjust address b 
	DD	RAT,PLUS,QDUP	; a 0 b" n" n?--, adjust count n?
	DD	QBRAN,NUMQ6
	DD	ONEM,TOR	; valid count, convert string 
NUMQ2:
	DD	DUPP,TOR,CAT 	; save address b and get next digit 
	DD	BASE,AT,DIGTQ	; convert it according to current radix 
	DD	QBRAN,NUMQ4	; If it is a valid digit 
	DD	SWAP,BASE,AT,STAR	; multiply it by radix 
	DD	PLUS,RFROM,ONEP	; add to sum. Increment address b 
	DD	DONXT,NUMQ2	; loop back to convert the next digit 
	DD	RAT,SWAP,DROP	; completely convert the string. get sign 
	DD	QBRAN,NUMQ3
	DD	NEGAT	; negate the sum if -flag is true 
NUMQ3:
	DD	SWAP	; sum a --
	DD	BRAN,NUMQ5
NUMQ4:
	DD	RFROM,RFROM,DDROP	; If a non-digit was encountered 
	DD	DDROP,DOLIT,0	; a 0 --, conversion failed 
NUMQ5:
	DD	DUPP	; sum a a --, if success; else a 0 0 --
NUMQ6:
	DD	RFROM,DDROP	; discard garbage 
	DD	RFROM,BASE,STORE,EXITT	; restore BASE 

;	Terminal I/O

;	NUF?	( -- t )
;	Return false if no input, else pause and if CR return true.

	$COLON	4,'nuf?',NUFQ
	DD	QKEY,DUPP	; got a key?
	DD	QBRAN,NUFQ1	; No. return a false flag 
	DD	DDROP,KEY	; Yes, get key
	DD	DOLIT,CRR,EQUAL	; Is it a CR? Return a flag.
NUFQ1:
	DD	EXITT	;

;	SPACE	( -- )
;	Send the blank character to the output device.

	$COLON	5,'SPACE',SPACE
	DD	BLANK,EMIT,EXITT	; send space 

;	SPACES	( +n -- )
;	Send n spaces to the output device.

	$COLON	6,'SPACES',SPACS
	DD	DOLIT,0,MAX,TOR	; avoid negative numbers 
	DD	BRAN,CHAR2
CHAR1:
	DD	SPACE	; send one space 
CHAR2:
	DD	DONXT,CHAR1	; loop back 
	DD	EXITT

;	TYPE	( b u -- )
;	Output u characters from b.

	$COLON	4,'TYPE',TYPES
	DD	TOR
	DD	BRAN,TYPE2	; skip one loop 
TYPE1:
	DD	DUPP,CAT,TCHAR,EMIT	; emit only printable characters 
	DD	ONEP	; b+1
TYPE2:
	DD	DONXT,TYPE1	; loop
	DD	DROP,EXITT	; discard b 

;	CR	( -- )
;	Output a carriage return and a line feed.

	$COLON	2,'CR',CR
	DD	DOLIT,CRR,EMIT	; CR
	DD	DOLIT,LF,EMIT,EXITT	; LF

;	Strings

;	DO$	( -- a )
;	Return the address of a compiled string.

	$COLON	COMPO+3,'do$',DOSTR
	DD	RFROM 	; 1st return address must be saved 
	DD	RAT,RFROM 	; 2nd return address points to counted string a 
	DD	COUNT,PLUS	; address of next token after string literal 
	DD	TOR,SWAP 	; replace 2nd return address 
	DD	TOR,EXITT	; restore saved 1st return address 

;	$"|	( -- a )
;	Run time routine compiled by $". Return address of a compiled string.

	$COLON	COMPO+3,'$"|',STRQP
	DD	DOSTR,EXITT	;force a call to do$

;	."|	( -- )
;	Run time routine of ." . Output a compiled string.

	$COLON	COMPO+3,'."|',DOTQP
	DD	DOSTR,COUNT,TYPES,EXITT	; display following string 

;	Parsing

;	(PARSE)	( b u c -- b u delta ; <string> )
;	Scan string delimited by c. Return found string and its offset.

	$COLON	7,'(parse)',PARS
	DD	TEMP,STORE,OVER 	; b u b --, save c 
	DD	TOR,DUPP	; b u u --, save b, test u 
	DD	QBRAN,PARS8	; if u=0, exit 
	DD	ONEM,TEMP,AT 	; u not 0, c=blank?
	DD	BLANK,EQUAL
	DD	QBRAN,PARS3	; u not blank, go forward 
	DD	TOR	; loop u times to skip blanks 
PARS1:
	DD	BLANK,OVER,CAT	; skip leading blanks 
	DD	SUBBB,ZLESS,INVER
	DD	QBRAN,PARS2	; found non-blanks character, go parsing 
	DD	ONEP
	DD	DONXT,PARS1	; b+1 --, end of loop 
	DD	RFROM,DROP 	; string is blank, exit 
	DD	DOLIT,0,DUPP,EXITT	; b 0 0 --
PARS2:
	DD	RFROM	; found non-blanks character, parse 
PARS3:
	DD	OVER,SWAP	; b b u --, start parsing non-space characters 
	DD	TOR	; loop u times to parse a string 
PARS4:
	DD	TEMP,AT,OVER,CAT,SUBBB	; scan for delimiter
	DD	TEMP,AT,BLANK,EQUAL
	DD	QBRAN,PARS5	; c is not blank 
	DD	ZLESS
PARS5:
	DD	QBRAN,PARS6	; c is blank, exit this loop 
	DD	ONEP	; b+1 --
	DD	DONXT,PARS4	; loop back to test next character 
	DD	DUPP,TOR	; save a copy of b at the end of the loop 
	DD	BRAN,PARS7	; found a valid string 
PARS6:
	DD	RFROM,DROP,DUPP	; discard loop count 
	DD	ONEP,TOR	; save a copy of b+1
PARS7:
	DD	OVER,SUBBB	; length of the parsed string 
	DD	RFROM,RFROM,SUBBB 	; and its offset in the buffer 
	DD	EXITT	; b u 0--
PARS8:
	DD	OVER,RFROM,SUBBB 	; b u delta --
	DD	EXITT

;	PARSE	( c -- b u ; <string> )
;	Scan input stream and return counted string delimited by c.

	$COLON	5,'parse',PARSE
	DD	TOR,TIB,INN,AT,PLUS	; current input buffer pointer to start parsing 
	DD	NTIB,AT,INN,AT,SUBBB	; length of remaining string in TIB
	DD	RFROM,PARS 	; parse desired string 
	DD	INN,PSTOR,EXITT	; move pointer to end of string 

;	.(	( -- )
;	Output following string up to next ) .

	$COLON	IMEDD+2,'.(',DOTPR
	DD	DOLIT,')',PARSE,TYPES,EXITT ; parse till ) and display parsed string

;	(	( -- )
;	Ignore following string up to next ) . A comment.

	$COLON	IMEDD+1,'(',PAREN
	DD	DOLIT,')',PARSE,DDROP,EXITT ; parse till ) and discard parsed string

;	\	( -- )
;	Ignore following text till the end of line.

	$COLON	IMEDD+1,'\',BKSLA
	DD	NTIB,AT,INN,STORE,EXITT	; make >IN equal to #TIB and terminate parsing

;	WORD	( c -- a ; <string> )
;	Parse a word from input stream and copy it to code dictionary.

	$COLON	4,'WORD',WORDD
	DD	PARSE	; parse till c
	DD	HERE,CELLP	; HERE+4
	DD	PACKS,EXITT	; pack parsed string to HERE buffer

;	TOKEN	( -- a ; <string> )
;	Parse a word from input stream and copy it to name dictionary.

	$COLON	5,'token',TOKEN
	DD	BLANK,WORDD 	; parse next string delimited by spaces 
	DD	EXITT	; pack parsed string to HERE buffer 

;	Dictionary search

;	NAME>	( na -- ca )
;	Return a code address given a name address.

	$COLON	5,'name>',NAMET
	DD	COUNT,DOLIT,31,ANDD	; mask lexicon byte to get length 
	DD	PLUS,EXITT	; skip over name field 

;	SAME?	( a1 a2 u -- a1 a2 f \ -0+ )
;	Compare u-2 bytes in two strings. Return 0 if identical.

	$COLON	5,'same?',SAMEQ
	DD	ONEM,TOR	; compare n-1 bytes 
	DD	BRAN,SAME2	; skip the first round 
SAME1:
	DD	OVER,RAT,PLUS,CAT	; get source byte 
	DD	OVER,RAT,PLUS,CAT	; get target byte 
	DD	SUBBB,QDUP	; compare 
	DD	QBRAN,SAME2	; same?
	DD	RFROM,DROP,EXITT	;not same, f<>0
SAME2:
	DD	DONXT,SAME1	; same, loop for next byte 
	DD	DOLIT,0,EXITT	; same, f=0

;	FIND	( a va -- cfa nfa | a F )
;	Search a vocabulary for a string. Return ca and na if succeeded.

	$COLON	4,'find',FIND
	DD	SWAP,DUPP,CAT	; va a count --
	DD	TEMP,STORE	; count saved in tmp
	DD	DUPP,AT,TOR,TWOP,SWAP	; a+2 va --, first 4 bytes saved on RS
FIND1:
	DD	AT,DUPP	; a+2 nfa nfa --, end of vocabulary?
	DD	QBRAN,FIND6	; end, return a 0
	DD	DUPP,TWOP,SWAP	; a+2 nfa+2 na --
	DD	AT,RAT,XORR,DOLIT,MASKK,ANDD	; a+2 na+2 f --, compare first 2 bytes
	DD	QBRAN,FIND2	; 2 bytes same, do SAME?
	DD	DOLIT,-1	; a+2 nfa+2 -1 --, not same, repeat
	DD	BRAN,FIND3
FIND2:
	DD	TEMP,AT,SAMEQ	; a+2 nfa+2 f --, compare rest of name
FIND3:
	DD	QBRAN,FIND5	; a+2 nfa+2 --
	DD	CELLM,TWOM	; a+2 lfa --, not this name
	DD	BRAN,FIND1	; go to next name
FIND5:
	DD	RFROM,DROP,SWAP,DROP	; nfa+2 --
	DD	TWOM	; na --
	DD	DUPP,NAMET,SWAP,EXITT	; cfa nfa --, find name
FIND6:
	DD	RFROM,DROP	;a+2 0 --, end of vocabulary
	DD	SWAP,TWOM,SWAP,EXITT	;a 0 --, return with 0 flag

;	NAME?	( a -- cfa nfa | a F )
;	Search all context vocabularies for a string.

	$COLON	5,'name?',NAMEQ
	DD	CNTXT,FIND,EXITT	; initial nfa is in CONTEXT 

;	Terminal input

;	^H	( bot eot cur -- bot eot cur )
;	Backup the cursor by one character.

	$COLON	2,'^h',BKSP
	DD	TOR,OVER,RFROM 	; bot eot bot cur --
	DD	SWAP,OVER,XORR	; bot=cur?
	DD	QBRAN,BACK1
	DD	DOLIT,BKSPP,EMIT,ONEM	; back space 
	DD	BLANK,EMIT	; send blank 
	DD	DOLIT,BKSPP,EMIT	; back space again 
BACK1:
	DD	EXITT	; bot=cur, do not back space 

;	TAP	( bot eot cur c -- bot eot cur )
;	Accept and echo the key stroke and bump the cursor.

	$COLON	3,'tap',TAP
	DD	DUPP,EMIT	; duplicate character and emit it 
	DD	OVER,CSTOR,ONEP ; store c at cur, and increment cur 
	DD	EXITT

;	kTAP	( bot eot cur c -- bot eot cur )
;	Process a key stroke, CR or backspace.

	$COLON	4,'ktap',KTAP
	DD	DUPP,DOLIT,CRR,XORR	; is key a return?
	DD	QBRAN,KTAP2
	DD	DOLIT,BKSPP,XORR	; is key a backspace?
	DD	QBRAN,KTAP1
	DD	BLANK,TAP,EXITT	; non of above, replace by a space 
KTAP1:
	DD	BKSP,EXITT	; process back space 
KTAP2:
	DD	DROP,SWAP,DROP,DUPP,EXITT	; process carriage return 

;	ACCEPT	( b u -- b u )
;	Accept characters to input buffer. Return with actual count.

	$COLON	6,'accept',ACCEP
	DD	OVER,PLUS,OVER	; b b+u1 b --
ACCP1:
	DD	DDUP,XORR	; b+u1 = current pointer?
	DD	QBRAN,ACCP4	; Yes, exit 
	DD	KEY,DUPP	; No, get next character 
	DD	BLANK,DOLIT,127,WITHI	; a valid character?
	DD	QBRAN,ACCP2
	DD	TAP	; Yes, accept it to input buffer 
	DD	BRAN,ACCP3
ACCP2:
	DD	KTAP	; No, process control character 
ACCP3:
	DD	BRAN,ACCP1	; loop for next character 
ACCP4:
	DD	DROP,OVER,SUBBB,EXITT	; done, return actual string length 

;	QUERY	( -- )
;	Accept input stream to terminal input buffer.

	$COLON	5,'query',QUERY
	DD	TIB,DOLIT,80,ACCEP	; accept up to 80 character to TIB 
	DD	NTIB,STORE,DROP 	; store actual string length in #TIB 
	DD	DOLIT,0,INN,STORE,EXITT	; init >IN 

;	Error handling

;	ABORT	( -- )
;	Reset data stack and jump to QUIT.

	$COLON	5,'ABORT',ABORT
	DD	PRESE,DOTS,QUIT	; dump stack as well 

;	ABORT"|	( f -- )
;	Run time routine of ABORT" . Abort with a message.

	$COLON	COMPO+7,'abort"|',ABORQ
	DD	QBRAN,ABOR2	; text flag
	DD	DOSTR	; get string address 
ABOR1:
	DD	SPACE,COUNT,TYPES	; display error string 
	DD	DOLIT,'?',EMIT,CR,ABORT  ; go pass error string
ABOR2:
	DD	DOSTR,DROP,EXITT	; drop error string

;	?stack	( -- )
;	Abort if the data stack underflows.

	$COLON	6,'?stack',QSTAC
	DD	DEPTH,ZLESS	; check only for underflow
	DD	ABORQ	; abort if true 
	DB	11,' underflow '
	DD	EXITT

;	Text interpreter

;	$INTERPRET	( a -- )
;	Interpret a word. If failed, try to convert it to an integer.

	$COLON	10,'$interpret',INTER
	DD	NAMEQ,QDUP	; word defined?
	DD	QBRAN,INTE1	; No. go convert to number 
	DD	AT,DOLIT,COMPO,ANDD	; test compile-only lexicon bit 
	DD	ABORQ	; If it is compile-only, abort 
	DB	13,' compile only'
	DD	EXECU,EXITT	; otherwise, execute defined word 
INTE1:
	DD	NUMBQ	; convert to a number 
	DD	QBRAN,ABOR1	; not a number, abort 
	DD	EXITT

;	[	( -- )
;	Start the text interpreter.

	$COLON	IMEDD+1,'[',LBRAC
	DD	DOLIT,INTER,TEVAL,STORE	; init EVAL with $INTERPRET 
	DD	EXITT

;	.OK	( -- )
;	Display 'ok' only while interpreting.

	$COLON	3,'.ok',DOTOK
	DD	CR,DOLIT,INTER,TEVAL,AT,EQUAL	; EVAL contains $INTRPRET?
	DD	QBRAN,DOTO1	; no, exit 
	DD	DOTS	; yes, dump stack 
DOTO1:
	DD	EXITT

;	EVAL	( -- )
;	Interpret the input stream.

	$COLON	4,'eval',EVAL
EVAL1:
	DD	TOKEN,DUPP,CAT	; input stream empty?
	DD	QBRAN,EVAL2	; yes, exit 
	DD	TEVAL,ATEXE,QSTAC	; no, evaluate input, check stack
	DD	BRAN,EVAL1	; loop back for next word 
EVAL2:
	DD	DROP,DOTOK,EXITT	; done, display prompt 

;	PRESET	( -- )
;	Reset data stack pointer and the terminal input buffer.

	$COLON	6,'preset',PRESE
	DD	DOLIT,_SPP,AT,SPSTO	; init data stack pointer 
	DD	EXITT

;	QUIT	( -- )
;	Reset return stack pointer and start text interpreter.

	$COLON	4,'quit',QUIT
	DD	DOLIT,_RPP,AT,RPSTO	; init return stack pointer
QUIT1:
	DD	LBRAC	; start interpretation
QUIT2:
	DD	QUERY	; get input
	DD	EVAL
	DD	BRAN,QUIT2	;continue till error

;	Compiler tools

;	'	( -- cfa )
;	Search dictionary for the next word in input stream.

	$COLON	1,"'",TICK
	DD	TOKEN,NAMEQ	; word defined?
	DD	QBRAN,ABOR1
	DD	EXITT	;yes, push code field address

;	ALLOT	( n -- )
;	Allocate n bytes to the code dictionary.

	$COLON	5,'ALLOT',ALLOT
	DD	CP,PSTOR,EXITT	;adjust code pointer

;	,	( w -- )
;	Compile an integer into the code dictionary.

	$COLON	1,',',COMMA
	DD	HERE,DUPP,CELLP,CP,STORE	; advance CP
	DD	STORE,EXITT	; compile w to dictionary

;	[COMPILE]	( -- ; <string> )
;	Compile the next immediate word into code dictionary.

	$COLON	IMEDD+9,'[compile]',BCOMP
	DD	TICK,COMMA,EXITT	; search next word and compile its cfa 

;	COMPILE	( -- )
;	Compile the next address in colon list to code dictionary.

	$COLON	COMPO+7,'compile',COMPI
	DD	RFROM,DUPP,AT,COMMA	;compile address
	DD	CELLP,TOR,EXITT	;adjust return address

;	LITERAL	( w -- )
;	Compile tos to code dictionary as an integer literal.

	$COLON	IMEDD+7,'literal',LITER
	DD	COMPI,DOLIT,COMMA,EXITT	; compile DOLIT and w as an integer literal 

;	$,"	( -- )
;	Compile a literal string up to next " .

	$COLON	3,'$,"',STRCQ
	DD	DOLIT,'"',PARSE,HERE,PACKS	; compile string to code dictionary 
	DD	COUNT,PLUS	;calculate aligned end of string
	DD	CP,STORE,EXITT	;adjust the code pointer

;	Control structures

;	FOR	( -- a )
;	Start a FOR-NEXT loop structure in a colon definition.

	$COLON	IMEDD+3,'FOR',FORR
	DD	COMPI,TOR 	; compile >R to start a FOR-NEXT loop 
	DD	HERE,EXITT	; leave address a of next token 

;	NEXT	( a -- )
;	Terminate a FOR-NEXT loop structure.

	$COLON	IMEDD+4,'NEXT',NEXT
	DD	COMPI,DONXT,COMMA 	; Compile DONXT address literal with address a 
	DD	EXITT

;	BEGIN	( -- a )
;	Start an infinite or indefinite loop structure.

	$COLON	IMEDD+5,'BEGIN',BEGIN
	DD	HERE,EXITT	; leave address a of next token 

;	UNTIL	( a -- )
;	Terminate a BEGIN-UNTIL indefinite loop structure.

	$COLON	IMEDD+5,'UNTIL',UNTIL
	DD	COMPI,QBRAN,COMMA 	; compile ?BRANCH address literal with address a 
	DD	EXITT

;	AGAIN	( a -- )
;	Terminate a BEGIN-AGAIN infinite loop structure.

	$COLON	IMEDD+5,'AGAIN',AGAIN
	DD	COMPI,BRAN,COMMA 	; compile BRANCH address literal with address a 
	DD	EXITT

;	IF	( -- A )
;	Begin a conditional branch structure.

	$COLON	IMEDD+2,'IF',IFF
	DD	COMPI,QBRAN,HERE	; compile ?BRANCH address literal, leave address A 
	DD	DOLIT,0,COMMA,EXITT	; init address field to 0

;	AHEAD	( -- A )
;	Compile a forward branch instruction.

	$COLON	IMEDD+5,'ahead',AHEAD
	DD	COMPI,BRAN,HERE 	; compile BRANCH address literal, leave address A 
	DD	DOLIT,0,COMMA,EXITT	; init address field to 0

;	REPEAT	( A a -- )
;	Terminate a BEGIN-WHILE-REPEAT indefinite loop.

	$COLON	IMEDD+6,'REPEAT',REPEA
	DD	AGAIN 	; compile BRANCH address literal with address a 
	DD	HERE,SWAP,STORE	; resolve address at A with current token address 
	DD	EXITT

;	THEN	( A -- )
;	Terminate a conditional branch structure.

	$COLON	IMEDD+4,'THEN',THENN
	DD	HERE,SWAP,STORE 	; resolve address at A with current token address 
	DD	EXITT

;	AFT	( a -- a A )
;	Jump to THEN in a FOR-AFT-THEN-NEXT loop the first time through.

	$COLON	IMEDD+3,'AFT',AFT
	DD	DROP,AHEAD	; compile a BRANCH address literal and leave A 
	DD	BEGIN,SWAP,EXITT	; replace a with address of current token 

;	ELSE	( A -- A )
;	Start the false clause in an IF-ELSE-THEN structure.

	$COLON	IMEDD+4,'ELSE',ELSEE
	DD	AHEAD,SWAP	; compile BRANCH address literal. resolve address at A 
	DD	THENN,EXITT	; with current token address. Replace A by literal address 

;	WHILE	( a -- A a )
;	Conditional branch out of a BEGIN-WHILE-REPEAT loop.

	$COLON	IMEDD+5,'WHILE',WHILEE
	DD	IFF,SWAP,EXITT	; compile BRANCH address literal. Leave literal address A 

;	String words

;	ABORT"	( -- ; <string> )
;	Conditional abort with an error message.

	$COLON	IMEDD+6,'ABORT"',ABRTQ
	DD	COMPI,ABORQ,STRCQ 	; compile abort?string literal with following string	DD	EXITT

;	$"	( -- ; <string> )
;	Compile an inline string literal.

	$COLON	IMEDD+2,'$"',STRQ
	DD	COMPI,STRQP,STRCQ 	; compile $| string literal with following string 
	DD	EXITT

;	."	( -- ; <string> )
;	Compile an inline string literal to be typed out at run time.

	$COLON	IMEDD+2,'."',DOTQ
	DD	COMPI,DOTQP,STRCQ 	; compile .?string literal with following string 
	DD	EXITT

;	Name field

;	?UNIQUE	( a -- a )
;	Display a warning message if the word already exists.

	$COLON	7,'?unique',UNIQU
	DD	DUPP,NAMEQ	; Word defined? 
	DD	QBRAN,UNIQ1
	DD	DOTQP	; redefinitions are OK
	DB	7,' reDef '	; but the user should be warned
	DD	OVER,COUNT,TYPES	; just in case it is not intended
UNIQ1:
	DD	DROP,EXITT

;	$,N	( nfa -- )
;	Build a new dictionary name using the string at nfa.

	$COLON	3,'$,n',SNAME
	DD	DUPP,CAT	; null input? 
	DD	QBRAN,PNAM1
	DD	UNIQU	; redefinition?
	DD	DUPP,COUNT,PLUS	; skip over name field 
	DD	CP,STORE	; CP points to code field now 
	DD	DUPP,LAST,STORE	; save nfa for dictionary link
	DD	CELLM	; link address
	DD	CNTXT,AT,SWAP	; fill link field with CONTEXT 
	DD	STORE,EXITT	; save code pointer
PNAM1:
	DD	STRQP	; warning message 
	DB	5,' name'	; null input
	DD	BRAN,ABOR1

;	Colon compiler

;	$COMPILE	( a -- )
;	Compile next word to code dictionary as a token or literal.

	$COLON	8,'$compile',SCOMP
	DD	NAMEQ,QDUP	; word defined? 
	DD	QBRAN,SCOM2
	DD	AT,DOLIT,IMEDD,ANDD	; immediate?
	DD	QBRAN,SCOM1
	DD	EXECU,EXITT	; its immediate, execute
SCOM1:
	DD	COMMA,EXITT	; its not immediate, compile
SCOM2:
	DD	NUMBQ	; try to convert to number
	DD	QBRAN,ABOR1
	DD	LITER,EXITT	; compile number as integer literal

;	OVERT	( -- )
;	Link a new word into the current vocabulary.

	$COLON	5,'overt',OVERT
	DD	LAST,AT,CNTXT,STORE 	; initialize CONTEXT from LAST 
	DD	EXITT

;	;	( -- )
;	Terminate a colon definition.

	$COLON	IMEDD+COMPO+1,';',SEMIS
	DD	COMPI,EXITT	; compile EXIT 
	DD	LBRAC,OVERT,EXITT	; return to interpret mode 

;	]	( -- )
;	Start compiling the words in the input stream.

	$COLON	1,']',RBRAC
	DD	DOLIT,SCOMP,TEVAL,STORE 	; change EVAL to $COMPIL 
	DD	EXITT	; switch to compile mode 

;	:	( -- ; <string> )
;	Start a new colon definition using next word as its name.

	$COLON	1,':',COLON
	DD	TOKEN,SNAME 	; get next string and build new name field 
	DD	DOLIT,DOLST,COMMA	; compile DOLST into code field 
	DD	RBRAC,EXITT	; switch to compile mode 

;	IMMEDIATE	( -- )
;	Make the last compiled word an immediate word.

	$COLON	9,'IMMEDIATE',IMMED
	DD	DOLIT,IMEDD 	; immediate bit 
	DD	LAST,AT,CAT,ORR 	; add it to lexicon byte in last name field 
	DD	LAST,AT,CSTOR,EXITT	; Store back to lexicon byte 

;	Defining words

;	CREATE	( -- ; <string> )
;	Compile a new array entry without allocating code space.

	$COLON	6,'CREATE',CREAT
	DD	TOKEN,SNAME,OVERT	; build new link and name fields 
	DD	DOLIT,DOVAR,COMMA	; compile DOVAR into code field 
	DD	EXITT

;	CONSTANT	( n -- ; <string> )
;	Compile a new constant.

	$COLON	8,'CONSTANT',CONST
	DD	TOKEN,SNAME,OVERT	; build new link and name fields 
	DD	DOLIT,DOCON,COMMA	; compile DOCON into code field 
	DD	COMMA,EXITT	; compile n into parameter field 

;	VARIABLE	( -- ; <string> )
;	Compile a new variable initialized to 0.

	$COLON	8,'VARIABLE',VARIA
	DD	CREAT	; compile link, name, and DOVAR code field 
	DD	DOLIT,0,COMMA,EXITT	; init parameter field to 0

;	Tools

;	DUMP	( a -- )
;	Dump 128 bytes from a, in a formatted manner.

	$COLON	4,'DUMP',DUMP
	DD	DOLIT,7	; set line count to 7 for 8 lines 
	DD	TOR	; start count down loop
DUMP1:
	DD	CR,DUPP,DOLIT,8,UDOTR	; display address
	DD	SPACE	; add a space 
	DD	DOLIT,15
	DD	TOR	
DUMP2:
	DD	COUNT,DOLIT,3,UDOTR	; display 16 bytes of data 
	DD	DONXT,DUMP2
	DD	SPACE,DUPP	; add  space 
	DD	DOLIT,16,SUBBB	; back up 16 bytes 
	DD	DOLIT,16,TYPES ; display 16 bytes of text
	DD	DONXT,DUMP1	; loop till done
	DD	DROP
	DD	EXITT

;	.S	( ... -- ... )
;	Display top 4 elements on data stack.

	$COLON	2,'.s',DOTS
	DD	TOR,TOR,TOR	; Save 3 items on stack 
	DD	DUPP,DOT,RFROM	; dump 4th item 
	DD	DUPP,DOT,RFROM	; dump 3rd item
	DD	DUPP,DOT,RFROM	; dump 2nd item 
	DD	DUPP,DOT	; dump 1st item 
	DD	DOTQP
	DB	3,' > '	; display separator 
	DD	EXITT

;	>NAME	( cfa -- nfa | F )
;	Convert code address to a name address.

	$COLON	5,'>name',TNAME
	DD	CNTXT	; dictionary link
TNAM2:
	DD	AT,DUPP	; last word in dictionary?
	DD	QBRAN,TNAM4	; Yes, reach end of dictionary 
	DD	DDUP,NAMET,XORR	; No, compare name
	DD	QBRAN,TNAM3	; word not found 
	DD	CELLM	; continue with next word
	DD	BRAN,TNAM2
TNAM3:
	DD	SWAP,DROP,EXITT	; found word, return nfa 
TNAM4:
	DD	DDROP,DOLIT,0,EXITT	; end of dictionary. Return false flag 

;	.ID	( nfa -- )
;	Display the name at name field address.

	$COLON	3,'.id',DOTID
	DD	QDUP	; if zero no name
	DD	QBRAN,DOTI1
	DD	COUNT,DOLIT,01FH,ANDD	; mask lexicon bits
	DD	TYPES,EXITT	; display name string
DOTI1:
	DD	DOTQP	; no name 
	DB	9,' {noName}'
	DD	EXITT

;	WORDS	( -- )
;	Display the names in the context vocabulary.

	$COLON	5,'WORDS',WORDS
	DD	CR,CNTXT	; start at CONTEXT 
WORS1:
	DD	AT,QDUP	; end of dictionary? 
	DD	QBRAN,WORS2	; Yes, exit 
	DD	DUPP,SPACE,DOTID	; display a name
	DD	CELLM,NUFQ	; user control
	DD	QBRAN,WORS1	; repeat next word 
	DD	DROP	; stop by user 
WORS2:
	DD	EXITT

;	SEE	( -- ; <string> )
;	A simple decompiler. Updated for byte machines, 08mar98cht

	$COLON	3,'SEE',SEE
	DD	TICK	; starting address
	DD	CR,CELLP
SEE1:
	DD	ONEP,DUPP,AT,DUPP	; does it contain a zero?
	DD	QBRAN,SEE2
	DD	TNAME	; is it a name?
SEE2:
	DD	QDUP	; name address or zero
	DD	QBRAN,SEE3
	DD	SPACE,DOTID	; display name
	DD	ONEP,TWOP	; next token 
	DD	BRAN,SEE4
SEE3:
	DD	DUPP,CAT,UDOT	; display number
SEE4:
	DD	NUFQ	; user control
	DD	QBRAN,SEE1	; decompile next token 
	DD	DROP,EXITT

;	Hardware reset

;	COLD	( -- )
;	The high level cold start sequence.

	$COLON	4,'cold',COLD
COLD1:
	DD	HEX,CR,DOTQP	; set base 
	DB	13,'86eForth v'	; version and 
	DB	VER+'0','.',EXT+'0'	; extension
	DD	CR,OVERT	; init data stack 
	DD	ABORT	; start interpretation

LASTN	=	_LINK	;last name address in dictionary

;===============================================================

MAIN	ENDP
END	MAIN

;===============================================================

